]> git.saurik.com Git - apt.git/blobdiff - test/integration/framework
Consider md5sum no longer a usable hash
[apt.git] / test / integration / framework
index 5d949009fc61e0f117459526e10e4ec8765ef986..ec5d7c491d8a1084a4200d24e94c3ce49cc3237a 100644 (file)
@@ -2,6 +2,20 @@
 
 EXIT_CODE=0
 
+while [ -n "$1" ]; do
+       if [ "$1" = "-q" ]; then
+               export MSGLEVEL=2
+       elif [ "$1" = "-v" ]; then
+               export MSGLEVEL=4
+       elif [ "$1" = '--color=no' ]; then
+               export MSGCOLOR='NO'
+       else
+               echo >&2 "WARNING: Unknown parameter »$1« will be ignored"
+       fi
+       shift
+done
+export MSGLEVEL="${MSGLEVEL:-3}"
+
 # we all like colorful messages
 if [ "$MSGCOLOR" != 'NO' ] && [ "$MSGCOLOR" != 'ALWAYS' ]; then
        if [ ! -t 1 ]; then # but check that we output to a terminal
@@ -51,20 +65,44 @@ msgndebug() { msgprintf "${CDEBUG}D: %s" '%s' "${CNORMAL}" "$@"; }
 msgtest() { msgprintf "${CINFO}%s" "${CCMD}%s${CINFO}" "…${CNORMAL} " "$@"; }
 msgpass() { printf "${CPASS}PASS${CNORMAL}\n"; }
 msgskip() {
+       if [ -n "$MSGTEST_MSG" ]; then
+               echo -n "$MSGTEST_MSG"
+               unset MSGTEST_MSG
+       fi
        if [ $# -gt 0 ]; then printf "${CWARNING}SKIP: $*${CNORMAL}\n" >&2;
        else printf "${CWARNING}SKIP${CNORMAL}\n" >&2; fi
 }
 msgfail() {
-       if [ $# -gt 0 ]; then printf "${CFAIL}FAIL: $*${CNORMAL}\n" >&2;
+       if [ -n "$MSGTEST_MSG" ]; then
+               if [ -n "$MSGTEST_GRP" ] && [ "$MSGTEST_GRP" != 'NEXT' ] && [ "$MSGTEST_GRP" != "$MSGTEST_MSG" ]; then
+                       echo "Part of the test group: $MSGTEST_GRP"
+               fi
+               echo -n "$MSGTEST_MSG"
+               unset MSGTEST_MSG
+       fi
+       if [ $# -gt 0 ] && [ -n "$1" ]; then printf "${CFAIL}FAIL: $*${CNORMAL}\n" >&2;
        else printf "${CFAIL}FAIL${CNORMAL}\n" >&2; fi
        if [ -n "$APT_DEBUG_TESTS" ]; then
                $SHELL
        fi
        EXIT_CODE=$((EXIT_CODE+1));
 }
+MSGGROUP_LEVEL=0
+msggroup() {
+       if [ -n "$1" ]; then
+               if [ $MSGGROUP_LEVEL = 0 ]; then
+                       MSGTEST_GRP='NEXT'
+               fi
+               MSGGROUP_LEVEL=$((MSGGROUP_LEVEL+1));
+       else
+               MSGGROUP_LEVEL=$((MSGGROUP_LEVEL-1));
+               if [ $MSGGROUP_LEVEL = 0 ]; then
+                       unset MSGTEST_GRP
+               fi
+       fi
+}
 
 # enable / disable Debugging
-MSGLEVEL=${MSGLEVEL:-3}
 if [ $MSGLEVEL -le 0 ]; then
        msgdie() { true; }
 fi
@@ -75,7 +113,12 @@ fi
 if [ $MSGLEVEL -le 2 ]; then
        msgmsg() { true; }
        msgnmsg() { true; }
-       msgtest() { true; }
+       msgtest() {
+               MSGTEST_MSG="$(msgprintf "${CINFO}%s" "${CCMD}%s${CINFO}" "…${CNORMAL} " "$@")"
+               if [ "$MSGTEST_GRP" = 'NEXT' ]; then
+                       MSGTEST_GRP="$MSGTEST_MSG"
+               fi
+       }
        msgpass() { printf " ${CPASS}P${CNORMAL}"; }
 fi
 if [ $MSGLEVEL -le 3 ]; then
@@ -99,10 +142,14 @@ msgdone() {
 }
 getaptconfig() {
        if [ -f ./aptconfig.conf ]; then
-            echo "./aptconfig.conf"
+               echo "$(readlink -f ./aptconfig.conf)"
        elif [ -f ../aptconfig.conf ]; then
-            echo "../aptconfig.conf"
-        fi
+               echo "$(readlink -f ../aptconfig.conf)"
+       elif [ -f ../../aptconfig.conf ]; then
+               echo "$(readlink -f ../../aptconfig.conf)"
+       elif [ -f "${TMPWORKINGDIRECTORY}/aptconfig.conf" ]; then
+               echo "$(readlink -f "${TMPWORKINGDIRECTORY}/aptconfig.conf")"
+       fi
 }
 runapt() {
        msgdebug "Executing: ${CCMD}$*${CDEBUG} "
@@ -141,8 +188,11 @@ gdb() {
        case "$1" in
        aptget) CMD="apt-get";;
        aptcache) CMD="apt-cache";;
+       aptcdrom) CMD="apt-cdrom";;
+       aptconfig) CMD="apt-config";;
        aptmark) CMD="apt-mark";;
        apthelper) CMD="apt-helper";;
+       aptftparchive) CMD="apt-ftparchive";;
        *) CMD="$1";;
        esac
        shift
@@ -184,7 +234,7 @@ setupenvironment() {
        fi
        TMPWORKINGDIRECTORY=$(mktemp -d)
        addtrap "cd /; rm -rf $TMPWORKINGDIRECTORY;"
-       msgninfo "Preparing environment for ${CCMD}$(basename $0)${CINFO} in ${TMPWORKINGDIRECTORY}… "
+       msgninfo "Preparing environment for $(basename $0) in ${TMPWORKINGDIRECTORY}…"
 
        mkdir -m 700 "${TMPWORKINGDIRECTORY}/downloaded"
        if [ "$(id -u)" = '0' ]; then
@@ -313,7 +363,6 @@ EOF
        export LC_ALL=C.UTF-8
        unset LANGUAGE APT_CONFIG
        unset GREP_OPTIONS DEB_BUILD_PROFILES
-
        msgdone "info"
 }
 
@@ -467,7 +516,7 @@ Dir::Bin::xz \"/does/not/exist\";" > "$CONFFILE"
                COMPRESSOR_CMD='xz --format=lzma'
        else
                msgtest 'Test for availability of compressor' "${COMPRESSOR}"
-               msgfail
+               msgfail "${COMPRESSOR} not available"
        fi
 }
 
@@ -563,10 +612,12 @@ echo '$NAME says \"Hello!\"'" > ${BUILDDIR}/${NAME}
 
  -- Joe Sixpack <joe@example.org>  $(date -R)" > ${BUILDDIR}/debian/changelog
        echo "Source: $NAME
-Section: $SECTION
 Priority: $PRIORITY
 Maintainer: Joe Sixpack <joe@example.org>
 Standards-Version: 3.9.3" > ${BUILDDIR}/debian/control
+       if [ "$SECTION" != '<none>' ]; then
+               echo "Section: $SECTION" >> ${BUILDDIR}/debian/control
+       fi
        local BUILDDEPS="$(echo "$DEPENDENCIES" | grep '^Build-')"
        test -z "$BUILDDEPS" || echo "$BUILDDEPS" >> ${BUILDDIR}/debian/control
        echo "
@@ -785,6 +836,7 @@ insertsource() {
        local ARCH="$3"
        local VERSION="$4"
        local DEPENDENCIES="$5"
+        local BINARY="${6:-$NAME}"
        local ARCHS=""
        local SPATH="aptarchive/dists/${RELEASE}/main/source"
        mkdir -p $SPATH
@@ -792,7 +844,7 @@ insertsource() {
        local DSCFILE="${NAME}_${VERSION}.dsc"
        local TARFILE="${NAME}_${VERSION}.tar.gz"
        echo "Package: $NAME
-Binary: $NAME
+Binary: $BINARY
 Version: $VERSION
 Maintainer: Joe Sixpack <joe@example.org>
 Architecture: $ARCH" >> $FILE
@@ -800,6 +852,9 @@ Architecture: $ARCH" >> $FILE
        echo "Files:
  $(echo -n "$DSCFILE" | md5sum | cut -d' ' -f 1) $(echo -n "$DSCFILE" | wc -c) $DSCFILE
  $(echo -n "$TARFILE" | md5sum | cut -d' ' -f 1) $(echo -n "$TARFILE" | wc -c) $TARFILE
+Checksums-Sha256:
+ $(echo -n "$DSCFILE" | sha256sum | cut -d' ' -f 1) $(echo -n "$DSCFILE" | wc -c) $DSCFILE
+ $(echo -n "$TARFILE" | sha256sum | cut -d' ' -f 1) $(echo -n "$TARFILE" | wc -c) $TARFILE
 " >> $FILE
 }
 
@@ -1061,8 +1116,9 @@ webserverconfig() {
        if downloadfile "$URI" "$STATUS" > "$DOWNLOG"; then
                msgpass
        else
-               cat "$DOWNLOG" "$STATUS" || true
-               msgfail
+               local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/webserverconfig.output"
+               cat "$DOWNLOG" "$STATUS" >"$OUTPUT" 2>&1 || true
+               msgfailoutput '' "$OUTPUT"
        fi
        $NOCHECK || testwebserverlaststatuscode '200'
 }
@@ -1186,30 +1242,49 @@ checkdiff() {
 }
 
 testfileequal() {
+       msggroup "$0"
+       local MSG='Test for correctness of file'
+       if [ "$1" = '--nomsg' ]; then
+               MSG=''
+               shift
+       fi
        local FILE="$1"
        shift
-       msgtest "Test for correctness of file" "$FILE"
+       if [ -n "$MSG" ]; then
+               msgtest "$MSG" "$FILE"
+       fi
+       local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testfileequal.output"
        if [ -z "$*" ]; then
-               echo -n "" | checkdiff - $FILE && msgpass || msgfail
+               if echo -n "" | checkdiff - $FILE >"$OUTPUT" 2>&1; then
+                       msgpass
+               else
+                       msgfailoutput '' "$OUTPUT"
+               fi
        else
-               echo "$*" | checkdiff - $FILE && msgpass || msgfail
+               if echo "$*" | checkdiff - $FILE >"$OUTPUT" 2>&1; then
+                       msgpass
+               else
+                       msgfailoutput '' "$OUTPUT"
+               fi
        fi
+       msggroup
 }
 
 testempty() {
+       msggroup "$0"
        msgtest "Test for no output of" "$*"
        local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testempty.comparefile"
        if "$@" >$COMPAREFILE 2>&1 && test ! -s $COMPAREFILE; then
                msgpass
        else
-               echo
-               cat $COMPAREFILE
-               msgfail
+               msgfailoutput '' "$COMPAREFILE"
        fi
        aptautotest 'testempty' "$@"
+       msggroup
 }
 
 testequal() {
+       msggroup "$0"
        local MSG='Test of equality of'
        if [ "$1" = '--nomsg' ]; then
                MSG=''
@@ -1223,11 +1298,18 @@ testequal() {
        if [ -n "$MSG" ]; then
                msgtest "$MSG" "$*"
        fi
-       "$@" 2>&1 | checkdiff $COMPAREFILE - && msgpass || msgfail
+       local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequal.output"
+       if "$@" 2>&1 | checkdiff $COMPAREFILE - >"$OUTPUT" 2>&1; then
+               msgpass
+       else
+               msgfailoutput '' "$OUTPUT"
+       fi
        aptautotest 'testequal' "$@"
+       msggroup
 }
 
 testequalor2() {
+       msggroup "$0"
        local COMPAREFILE1="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequalor2.comparefile1"
        local COMPAREFILE2="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequalor2.comparefile2"
        local COMPAREAGAINST="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequalor2.compareagainst"
@@ -1241,16 +1323,19 @@ testequalor2() {
        then
                msgpass
        else
-               echo -n "\n${CINFO}Diff against OR 1${CNORMAL}"
-               checkdiff $COMPAREFILE1 $COMPAREAGAINST || true
-               echo -n "${CINFO}Diff against OR 2${CNORMAL}"
-               checkdiff $COMPAREFILE2 $COMPAREAGAINST || true
-               msgfail
+               local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequal.output"
+               echo -n "\n${CINFO}Diff against OR 1${CNORMAL}" >"$OUTPUT" 2>&1
+               checkdiff "$COMPAREFILE1" "$COMPAREAGAINST" >"$OUTPUT" 2>&1 || true
+               echo -n "${CINFO}Diff against OR 2${CNORMAL}" >"$OUTPUT" 2>&1
+               checkdiff "$COMPAREFILE2" "$COMPAREAGAINST" >"$OUTPUT" 2>&1 || true
+               msgfailoutput '' "$OUTPUT"
        fi
        aptautotest 'testequalor2' "$@"
+       msggroup
 }
 
 testshowvirtual() {
+       msggroup "$0"
        local VIRTUAL="N: Can't select versions from package '$1' as it is purely virtual"
        local PACKAGE="$1"
        shift
@@ -1265,46 +1350,62 @@ N: Can't select versions from package '$1' as it is purely virtual"
 N: No packages found"
        local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testshowvirtual.comparefile"
        local ARCH="$(getarchitecture 'native')"
-       echo "$VIRTUAL" | sed -e "s/:$ARCH//" -e 's/:all//' > $COMPAREFILE
-       aptcache show -q=0 $PACKAGE 2>&1 | checkdiff $COMPAREFILE - && msgpass || msgfail
+       echo "$VIRTUAL" | sed -e "s/:$ARCH//" -e 's/:all//' >"$COMPAREFILE"
+       local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testshowvirtual.output"
+       if aptcache show -q=0 "$PACKAGE" 2>&1 | checkdiff "$COMPAREFILE" - >"$OUTPUT" 2>&1; then
+               msgpass
+       else
+               msgfailoutput '' "$OUTPUT"
+       fi
+       msggroup
 }
 
 testnopackage() {
+       msggroup "$0"
        msgtest "Test for non-existent packages" "apt-cache show $*"
        local SHOWPKG="$(aptcache show "$@" 2>&1 | grep '^Package: ')"
        if [ -n "$SHOWPKG" ]; then
-               echo >&2
-               echo >&2 "$SHOWPKG"
-               msgfail
+               local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testnopackage.output"
+               echo "$SHOWPKG" >"$OUTPUT"
+               msgfailoutput '' "$OUTPUT"
        else
                msgpass
        fi
+       msggroup
 }
 
 testdpkgstatus() {
+       msggroup "$0"
        local STATE="$1"
        local NR="$2"
        shift 2
        msgtest "Test that $NR package(s) are in state $STATE with" "dpkg -l $*"
        local PKGS="$(dpkg -l "$@" 2>/dev/null | grep "^${STATE}" | wc -l)"
        if [ "$PKGS" != $NR ]; then
-               echo >&2 $PKGS
-               dpkg -l "$@" | grep '^[a-z]' >&2
-               msgfail
+               local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testnopackage.output"
+               echo "$PKGS" >"$OUTPUT"
+               dpkg -l "$@" | grep '^[a-z]' >"$OUTPUT" >&2 || true
+               msgfailoutput '' "$OUTPUT"
        else
                msgpass
        fi
+       msggroup
 }
 
 testdpkginstalled() {
+       msggroup "$0"
        testdpkgstatus 'ii' "$#" "$@"
+       msggroup
 }
 
 testdpkgnotinstalled() {
+       msggroup "$0"
        testdpkgstatus 'ii' '0' "$@"
+       msggroup
 }
 
 testmarkedauto() {
+       msggroup "$0"
        local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testmarkedauto.comparefile"
        if [ -n "$1" ]; then
                msgtest 'Test for correctly marked as auto-installed' "$*"
@@ -1313,20 +1414,53 @@ testmarkedauto() {
                msgtest 'Test for correctly marked as auto-installed' 'no package'
                echo -n > $COMPAREFILE
        fi
-       aptmark showauto 2>&1 | checkdiff $COMPAREFILE - && msgpass || msgfail
+       local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testmarkedauto.output"
+       if aptmark showauto 2>&1 | checkdiff $COMPAREFILE - >"$OUTPUT" 2>&1; then
+               msgpass
+       else
+               msgfailoutput '' "$OUTPUT"
+       fi
+       msggroup
+}
+testmarkedmanual() {
+       msggroup "$0"
+       local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testmarkedmanual.comparefile"
+       if [ -n "$1" ]; then
+               msgtest 'Test for correctly marked as manually installed' "$*"
+               while [ -n "$1" ]; do echo "$1"; shift; done | sort > $COMPAREFILE
+       else
+               msgtest 'Test for correctly marked as manually installed' 'no package'
+               echo -n > $COMPAREFILE
+       fi
+       local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testmarkedmanual.output"
+       if aptmark showmanual 2>&1 | checkdiff $COMPAREFILE - >"$OUTPUT" 2>&1; then
+               msgpass
+       else
+               msgfailoutput '' "$OUTPUT"
+       fi
+       msggroup
 }
 
 msgfailoutput() {
+       if [ -n "$MSGTEST_MSG" ]; then
+               echo
+               if [ -n "$MSGTEST_GRP" ] && [ "$MSGTEST_GRP" != 'NEXT' ] && [ "$MSGTEST_GRP" != "$MSGTEST_MSG" ]; then
+                       echo "${CFAIL}Part of the test group: $MSGTEST_GRP"
+               fi
+               echo -n "$MSGTEST_MSG"
+               unset MSGTEST_MSG
+       fi
        local MSG="$1"
        local OUTPUT="$2"
        shift 2
-       echo >&2
        if [ "$1" = 'grep' ]; then
+               echo >&2
                while [ -n "$2" ]; do shift; done
                echo "#### Complete file: $1 ####"
                cat >&2 "$1" || true
                echo '#### grep output ####'
        elif [ "$1" = 'test' ]; then
+               echo >&2
                # doesn't support ! or non-file flags
                msgfailoutputstatfile() {
                        local FILEFLAGS='^-[bcdefgGhkLOprsStuwx]$'
@@ -1347,6 +1481,7 @@ msgfailoutput() {
 }
 
 testsuccess() {
+       msggroup "$0"
        if [ "$1" = '--nomsg' ]; then
                shift
        else
@@ -1357,8 +1492,17 @@ testsuccess() {
                if expr match "$1" '^apt.*' >/dev/null; then
                        if grep -q -E ' runtime error: ' "$OUTPUT"; then
                                msgfailoutput 'compiler detected undefined behavior' "$OUTPUT" "$@"
-                       elif grep -q -E '^[WE]: ' "$OUTPUT"; then
-                               msgfailoutput 'successful run, but output contains warnings/errors' "$OUTPUT" "$@"
+                       elif grep -E '^[WE]: ' "$OUTPUT" > "${TMPWORKINGDIRECTORY}/rootdir/tmp/checkforwarnings.output" 2>&1; then
+                               if [ "$IGNORE_PTY_NOT_MOUNTED" = '1' ]; then
+                                       if echo 'E: Can not write log (Is /dev/pts mounted?) - posix_openpt (2: No such file or directory)' \
+                                               | cmp - "${TMPWORKINGDIRECTORY}/rootdir/tmp/checkforwarnings.output" >/dev/null 2>&1; then
+                                               msgpass
+                                       else
+                                               msgfailoutput 'successful run, but output contains warnings/errors' "$OUTPUT" "$@"
+                                       fi
+                               else
+                                       msgfailoutput 'successful run, but output contains warnings/errors' "$OUTPUT" "$@"
+                               fi
                        else
                                msgpass
                        fi
@@ -1370,8 +1514,10 @@ testsuccess() {
                msgfailoutput "exitcode $EXITCODE" "$OUTPUT" "$@"
        fi
        aptautotest 'testsuccess' "$@"
+       msggroup
 }
 testwarning() {
+       msggroup "$0"
        if [ "$1" = '--nomsg' ]; then
                shift
        else
@@ -1394,13 +1540,13 @@ testwarning() {
                fi
        else
                local EXITCODE=$?
-               echo >&2
-               cat >&2 $OUTPUT
-               msgfail "exitcode $EXITCODE"
+               msgfailoutput "exitcode $EXITCODE" "$OUTPUT" "$@"
        fi
        aptautotest 'testwarning' "$@"
+       msggroup
 }
 testfailure() {
+       msggroup "$0"
        if [ "$1" = '--nomsg' ]; then
                shift
        else
@@ -1413,71 +1559,100 @@ testfailure() {
        else
                local EXITCODE=$?
                if expr match "$1" '^apt.*' >/dev/null; then
-                       if grep -q -E ' runtime error: ' "$OUTPUT"; then
-                               msgfailoutput 'compiler detected undefined behavior' "$OUTPUT" "$@"
-                       elif ! grep -q -E '^E: ' "$OUTPUT"; then
-                               msgfailoutput "run failed with exitcode ${EXITCODE}, but with no errors" "$OUTPUT" "$@"
+                       if [ "$1" = 'aptkey' ]; then
+                               if grep -q -E " Can't check signature: " "$OUTPUT" || \
+                                       grep -q -E " BAD signature from " "$OUTPUT"; then
+                                       msgpass
+                               else
+                                       msgfailoutput "run failed with exitcode ${EXITCODE}, but no signature error" "$OUTPUT" "$@"
+                               fi
                        else
-                               msgpass
+                               if grep -q -E ' runtime error: ' "$OUTPUT"; then
+                                       msgfailoutput 'compiler detected undefined behavior' "$OUTPUT" "$@"
+                               elif grep -q -E '==ERROR' "$OUTPUT"; then
+                                       msgfailoutput 'compiler sanitizers reported errors' "$OUTPUT" "$@"
+                               elif ! grep -q -E '^E: ' "$OUTPUT"; then
+                                       msgfailoutput "run failed with exitcode ${EXITCODE}, but with no errors" "$OUTPUT" "$@"
+                               else
+                                       msgpass
+                               fi
                        fi
                else
                        msgpass
                fi
        fi
        aptautotest 'testfailure' "$@"
+       msggroup
 }
 
 testsuccessequal() {
+       msggroup "$0"
        local CMP="$1"
        shift
        testsuccess "$@"
        testfileequal "${TMPWORKINGDIRECTORY}/rootdir/tmp/testsuccess.output" "$CMP"
+       msggroup
 }
 testwarningequal() {
+       msggroup "$0"
        local CMP="$1"
        shift
        testwarning "$@"
        testfileequal "${TMPWORKINGDIRECTORY}/rootdir/tmp/testwarning.output" "$CMP"
+       msggroup
 }
 testfailureequal() {
+       msggroup "$0"
        local CMP="$1"
        shift
        testfailure "$@"
        testfileequal "${TMPWORKINGDIRECTORY}/rootdir/tmp/testfailure.output" "$CMP"
+       msggroup
 }
 
 testfailuremsg() {
+       msggroup "$0"
        local CMP="$1"
        shift
        testfailure "$@"
        msgtest 'Check that the output of the previous failed command has expected' 'failures and warnings'
-       grep '^\(W\|E\):' "${TMPWORKINGDIRECTORY}/rootdir/tmp/testfailure.output" > "${TMPWORKINGDIRECTORY}/rootdir/tmp/testfailureequal.output" 2>&1 || true
-       if echo "$CMP" | checkdiff - "${TMPWORKINGDIRECTORY}/rootdir/tmp/testfailureequal.output"; then
+       local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testfailuremsg.comparefile"
+       grep '^\(W\|E\):' "${TMPWORKINGDIRECTORY}/rootdir/tmp/testfailure.output" > "$COMPAREFILE" 2>&1 || true
+       local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testfailuremsg.output"
+       if echo "$CMP" | checkdiff - "${COMPAREFILE}" >"$OUTPUT" 2>&1; then
                msgpass
        else
-               echo '### Complete output ###'
-               cat "${TMPWORKINGDIRECTORY}/rootdir/tmp/testfailure.output"
-               msgfail
+               echo '### Complete output ###' >"$OUTPUT"
+               cat "${TMPWORKINGDIRECTORY}/rootdir/tmp/testfailure.output" >"$OUTPUT"
+               msgfailoutput '' "$OUTPUT"
        fi
+       msggroup
 }
 
 testfilestats() {
+       msggroup "$0"
        msgtest "Test that file $1 has $2 $3" "$4"
        if [ "$4" "$3" "$(stat --format "$2" "$1")" ]; then
                msgpass
        else
-               echo >&2
-               ls -ld >&2 "$1" || true
-               echo -n >&2 "stat(1) reports for $2: "
-               stat --format "$2" "$1" || true
-               msgfail
+               local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testfilestats.output"
+               {
+                       ls -ld "$1" || true
+                       echo -n "stat(1) reports for $2: "
+                       stat --format "$2" "$1" || true
+               } >"$OUTPUT" 2>&1
+               msgfailoutput '' "$OUTPUT"
        fi
+       msggroup
 }
 testaccessrights() {
+       msggroup "$0"
        testfilestats "$1" '%a' '=' "$2"
+       msggroup
 }
 
 testwebserverlaststatuscode() {
+       msggroup "$0"
        local DOWNLOG='rootdir/tmp/webserverstatus-testfile.log'
        local STATUS='downloaded/webserverstatus-statusfile.log'
        rm -f "$DOWNLOG" "$STATUS"
@@ -1485,16 +1660,19 @@ testwebserverlaststatuscode() {
        if downloadfile "http://localhost:8080/_config/find/aptwebserver::last-status-code" "$STATUS" > "$DOWNLOG" && [ "$(cat "$STATUS")" = "$1" ]; then
                msgpass
        else
-               echo >&2
-               if [ -n "$2" ]; then
-                       shift
-                       echo >&2 '#### Additionally provided output files contain:'
-                       cat >&2 "$@"
-               fi
-               echo >&2 '#### Download log of the status code:'
-               cat >&2 "$DOWNLOG"
-               msgfail "Status was $(cat "$STATUS")"
+               local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testwebserverlaststatuscode.output"
+               {
+                       if [ -n "$2" ]; then
+                               shift
+                               echo >&2 '#### Additionally provided output files contain:'
+                               cat >&2 "$@"
+                       fi
+                       echo >&2 '#### Download log of the status code:'
+                       cat >&2 "$DOWNLOG"
+               } >"$OUTPUT" 2>&1
+               msgfailoutput "Status was $(cat "$STATUS")" "$OUTPUT"
        fi
+       msggroup
 }
 
 pause() {
@@ -1514,7 +1692,7 @@ listcurrentlistsdirectory() {
        } | sort
 }
 
-### convinience hacks ###
+### convenience hacks ###
 mkdir() {
        # creating some directories by hand is a tedious task, so make it look simple
        if [ "$*" = '-p rootdir/var/lib/apt/lists' ] || [ "$*" = "${TMPWORKINGDIRECTORY}/rootdir/var/lib/apt/lists" ] ||